SystemOrganization addCategory: #TP1!

Trait named: #NoPoceado
	uses: {}
	category: 'TP1'!

!NoPoceado methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 12:22'!
montoDeApuesta

self requirement! !

!NoPoceado methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 12:45'!
pagarA:unosGanadores numero:unasVeces

unosGanadores do: [:apuestaGanadora | apuestaGanadora jugador recibiPlata: (self montoDeApuesta: apuestaGanadora)   * unasVeces].! !

!NoPoceado methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:48'!
pagarlesAlasAgencias
| tamanio |
self apuestas do: [:apuesta | apuesta agencia recibiPlata: (self porcentajeAgencia * self montoDeApuesta:apuesta /100)].

tamanio:= self premios first misGanadores size. 

(self pagoExtra & tamanio >0 )ifTrue: [ self premios first misGanadores do: [:apuestaGanadora |apuestaGanadora agencia recibiPlata: (self porcentajeAgenciaExtra * (self pozo) / 100/tamanio) ] ].
^tamanio.! !

Trait named: #Poceado
	uses: {}
	category: 'TP1'!

!Poceado methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 16:52'!
apuestas 
 self requirement.! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 16:21'!
pagarA:unosGanadores numero:unPorcentaje
| monto |
monto:= self pozo * unPorcentaje /100 / (unosGanadores size).

unosGanadores do: [:apuestaGanadora | apuestaGanadora jugador recibiPlata: monto].
! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:34'!
pagarlesAlasAgencias
| tamanio |
self apuestas do: [:apuesta | apuesta agencia recibiPlata: (self porcentajeAgencia * self pozo /100/ self apuestas size)].

tamanio:= self premios first misGanadores size. 

(self pagoExtra & tamanio >0 )ifTrue: [ self premios first misGanadores do: [:apuestaGanadora |apuestaGanadora agencia recibiPlata: (self porcentajeAgenciaExtra * (self pozo) / 100/tamanio) ] ].
^tamanio.! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:35'!
pagoExtra
^self requirement.! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:34'!
porcentajeAgencia
^self requirement.! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:34'!
porcentajeAgenciaExtra 
^self requirement.! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 16:54'!
pozo
^ self apuestas inject: 0 into: [:acum :apuesta | acum + apuesta montoApostado ].! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:35'!
premios
^self requirement.! !

Trait named: #ReceptorDinero
	uses: {}
	category: 'TP1'!

!ReceptorDinero methodsFor: 'as yet unclassified' stamp: 'Fede 9/2/2012 23:18'!
capital
self requirement.! !

!ReceptorDinero methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 11:13'!
capital:unMonto 
	self requirement! !

!ReceptorDinero methodsFor: 'as yet unclassified' stamp: 'MPampin 9/7/2012 02:50'!
recibiPlata: unDinero 


self capital: (self capital + unDinero). 
! !

TestCase subclass: #ApuestaTest
	instanceVariableNames: 'agencia apuesta misApuestas pedro eleccionPedro sorteoProde agencia1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

!ApuestaTest methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 10:26'!
TestAgregoApuestaAlSorteo

pedro := Jugador new.
eleccionPedro := OrderedCollection new.
sorteoProde:=Sorteo new.
eleccionPedro add: 1.
eleccionPedro add: 2.
eleccionPedro add: 3.
agencia1 := Agencia new.
pedro jugar: eleccionPedro en: sorteoProde apostando:20 en:agencia1.

self assert: 1 equals: sorteoProde apuestas size. ! !

TestCase subclass: #JugarTest
	instanceVariableNames: 'agencia apuesta misApuestas pedro eleccionPedro sorteoProde agencia1 criterio1 prode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

!JugarTest methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 13:03'!
TestJugarHastaObtenerGanadores

pedro := Jugador new.
eleccionPedro := OrderedCollection new.

criterio1 :=Criterio new.
prode:=Prode nuevoconPorcentajeParaAgencia: 100 yPagoExtra:false.
prode crearPremioCon: criterio1 yNumero: 1 .




sorteoProde:=Sorteo new.
sorteoProde juego: prode.

eleccionPedro add: 1.
eleccionPedro add: 2.
eleccionPedro add: 3.
agencia1 := Agencia new.
pedro jugar: eleccionPedro en: sorteoProde apostando:20 en:agencia1.

sorteoProde jugar.
! !

TestCase subclass: #TestGeneraNumeros
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

!TestGeneraNumeros methodsFor: 'as yet unclassified' stamp: 'MPampin 9/7/2012 00:26'!
testGeneraCincoNumerosDeUnoACien

self assert: ((GenerarResultadoRandom obtener:5 hasta:100) size) equals: 5.
self assert: ((GenerarResultadoRandom obtenerSinRepetir:20 hasta:50) size) equals: 20.! !

TestCase subclass: #TestPagaOPaga
	instanceVariableNames: 'pop sorteo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

!TestPagaOPaga methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:53'!
testCrearPagaOPaga
|eleccionPedro pedro agencia|
sorteo := Sorteo new.
pop := PagaOPaga nuevoconPorcentajeParaAgencia: 10 yPagoExtra:false.
sorteo juego: pop.
agencia := Agencia new.
agencia capital: 100.

pedro := Jugador new.
pedro capital: 0.
eleccionPedro := OrderedCollection new.

eleccionPedro add: 20.
eleccionPedro add: 10.
eleccionPedro add: 56.
eleccionPedro add: 89.
eleccionPedro add: 36.
eleccionPedro add: 5.
eleccionPedro add: 18.
eleccionPedro add: 99.
eleccionPedro add: 15.
eleccionPedro add: 76.
eleccionPedro add: 87.
eleccionPedro add: 21.
eleccionPedro add: 36.
eleccionPedro add: 80.
eleccionPedro add: 96.

pedro jugar: eleccionPedro en: sorteo apostando:40 en:agencia.
sorteo jugar.
! !

Object subclass: #Agencia
	uses: ReceptorDinero
	instanceVariableNames: 'cuenta capital'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

Agencia class
	uses: ReceptorDinero classTrait
	instanceVariableNames: ''!

!Agencia methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 11:10'!
capital
^ capital.! !

!Agencia methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 11:13'!
capital:unMonto 
	capital := unMonto .! !

!Agencia methodsFor: 'as yet unclassified' stamp: 'Fede 9/3/2012 16:31'!
initialize 
capital := 0.
eleccion := OrderedCollection new.! !

Object subclass: #Apuesta
	instanceVariableNames: 'jugador juego montoApostado numerosApostados agencia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Fede 9/5/2012 12:47'!
agencia
^agencia! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 10:38'!
agencia: unaAgencia 
agencia := unaAgencia  .! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 10:39'!
initialize 
numerosApostados := OrderedCollection new.! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Fede 9/2/2012 23:27'!
juego
^juego! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 10:38'!
juego:unJuego
juego := unJuego.! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Fede 9/2/2012 23:25'!
jugador
^jugador.! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 10:37'!
jugador:unJugador
jugador := unJugador .! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Fede 9/2/2012 23:27'!
montoApostado
^montoApostado! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 10:38'!
montoApostado:unMonto
montoApostado := unMonto.! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Fede 9/2/2012 23:29'!
numerosApostados

^numerosApostados.! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 10:38'!
numerosApostados:unaColeccion

numerosApostados := unaColeccion .! !

Object subclass: #Criterio
	instanceVariableNames: 'Resultados nroAciertos cantidadIgualdades longitudColeccion apuesta resultados validaApuesta acum i'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

!Criterio methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 13:14'!
acum 
^acum.! !

!Criterio methodsFor: 'as yet unclassified' stamp: 'Fede 9/2/2012 23:45'!
cantidadIgualdades
^cantidadIgualdades .! !

!Criterio methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 11:49'!
cantidadIgualdades:unaCantidad
cantidadIgualdades := unaCantidad.! !

!Criterio methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 15:35'!
compara: unaEleccion con: unResultado


1 to: (unaEleccion size) do: [ :index | 
					(unaEleccion at: index) = (unResultado at: index) ifTrue:[acum := acum+1] 
			 ].
^ (acum = cantidadIgualdades) .! !

!Criterio methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 15:35'!
initialize 
acum:=0.
! !

Object subclass: #GenerarResultadoRandom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

GenerarResultadoRandom class
	instanceVariableNames: 'rndGen'!

GenerarResultadoRandom class
	instanceVariableNames: 'rndGen'!

!GenerarResultadoRandom class methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 01:04'!
genera: cant hasta: maximo en: coleccion



[coleccion size < cant] whileTrue: [
	coleccion add: (self rndGen nextInt: maximo) - 1.
].

^ coleccion.! !

!GenerarResultadoRandom class methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 00:59'!
obtener: cant hasta: maximo

^ self genera: cant hasta: maximo en: (OrderedCollection new).! !

!GenerarResultadoRandom class methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 23:57'!
obtenerSinRepetir: cant hasta: maximo

^ self genera: cant hasta: maximo en: (Set new).! !

!GenerarResultadoRandom class methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 23:57'!
rndGen
	rndGen == nil ifTrue:[ rndGen := Random new].
	^ rndGen! !

!GenerarResultadoRandom class methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 23:57'!
rndGen: anObject
	rndGen := anObject! !

Object subclass: #Juego
	instanceVariableNames: 'premios jugadores misApuestas porcentajeAgencia juego porcentajeAgenciaExtra pozo pagoExtra premio apuestas resultados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

Juego class
	instanceVariableNames: 'juego premio premios'!

Juego class
	instanceVariableNames: 'juego premio premios'!

!Juego class methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 17:44'!
nuevoconPorcentajeParaAgencia: unPorcentaje yPagoExtra:unBooleano
juego:= self new.
juego pagoExtra: unBooleano .
juego porcentajeAgencia: unPorcentaje .
^juego.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/2/2012 23:50'!
agregarPremio: unPremio
premios add: unPremio .! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 12:03'!
apuestas 
^apuestas.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 15:23'!
apuestas:unaApuesta
apuestas add: unaApuesta.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 12:42'!
crearPremioCon:unCriterio yNumero:unNumero

premio := Premio new.
premio criterio: unCriterio.

premio juego: self.
premio numero: unNumero.
premios add: premio.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 12:55'!
ganaAlgunPremio:unaApuesta
premios do: [:unPremio | unPremio sosGanadoPor:unaApuesta].! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 17:55'!
generarPremios
	! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 16:41'!
initialize 
premios := OrderedCollection  new.
apuestas  := OrderedCollection new.
resultados := OrderedCollection new.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:06'!
jugarCon: unasApuestas.
apuestas := unasApuestas .
"Ac ira obtenerResultadosRandom, pero lo evitamos para probar con nmeros hardcodeados, sino casi nunca hay coincidencia".

self obtenerGanadores .

self pagarlesATodosLosJugadores .

self pagarlesAlasAgencias .! !

!Juego methodsFor: 'as yet unclassified' stamp: 'MPampin 9/7/2012 02:01'!
montoDeApuesta: unaApuesta

^ unaApuesta montoApostado.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 12:55'!
obtenerGanadores
apuestas do: [:unaApuesta | self ganaAlgunPremio: unaApuesta ].! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 15:32'!
obtenerResultadoRandom 
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 16:26'!
pagarlesATodosLosJugadores
premios do: [:unPremio | unPremio misGanadores size >0 ifTrue: [ self pagarA: unPremio misGanadores numero: unPremio numero]].! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/5/2012 13:56'!
pagoExtra 
^pagoExtra .! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 11:48'!
pagoExtra:unBooleano 
pagoExtra := unBooleano .! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/5/2012 12:20'!
porcentajeAgencia
^porcentajeAgencia.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 11:49'!
porcentajeAgencia:unPorcentaje

porcentajeAgencia:= unPorcentaje .! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 17:42'!
porcentajeAgenciaExtra
^porcentajeAgenciaExtra.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 17:42'!
porcentajeAgenciaExtra:unPorcentaje
porcentajeAgenciaExtra:=unPorcentaje .! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 10:27'!
premios
^premios.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 16:41'!
resultados
^resultados.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 13:30'!
resultados:unosResultados
resultados:=unosResultados .! !

Juego subclass: #Loto
	uses: Poceado
	instanceVariableNames: 'criterio1 criterio2 criterio3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

Loto class
	uses: Poceado classTrait
	instanceVariableNames: ''!

!Loto methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:11'!
apuestas 
^apuestas.! !

!Loto methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 17:59'!
generarPremios 

criterio1 := Criterio new.
criterio1 cantidadIgualdades: 6.
criterio2 := Criterio new.
criterio2 cantidadIgualdades: 5.
criterio3 := Criterio new.
criterio3 cantidadIgualdades: 4.
self crearPremioCon: criterio1 yNumero: 40.
self crearPremioCon: criterio2 yNumero: 17.
self crearPremioCon: criterio3 yNumero: 5.
! !

!Loto methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:09'!
obtenerResultadoRandom 
^resultados := GenerarResultadoRandom obtener: 6 hasta: 39.
! !

!Loto methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:38'!
pagoExtra
^pagoExtra! !

!Loto methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:38'!
porcentajeAgencia
^porcentajeAgencia! !

!Loto methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:38'!
porcentajeAgenciaExtra 
^porcentajeAgenciaExtra! !

!Loto methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:37'!
premios
^premios! !

Juego subclass: #PagaOPaga
	uses: NoPoceado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

PagaOPaga class
	uses: NoPoceado classTrait
	instanceVariableNames: ''!

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'MPampin 9/7/2012 02:40'!
comparaConResultado: unaApuesta

^ (unaApuesta numerosApostados intersection: self resultados) size.! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'MPampin 9/7/2012 02:40'!
montoDeApuesta: unaApuesta

^ self premioAciertos: (self comparaConResultado: unaApuesta) monto: unaApuesta montoApostado.! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 11:59'!
obtenerGanadores

|nuevoPremio|

self apuestas do: [:apuesta |
	nuevoPremio := Premio new.
	nuevoPremio misGanadores add: apuesta.
	nuevoPremio juego: self.
	nuevoPremio numero: 0.7.
	self premios add: nuevoPremio.
]! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'MPampin 9/7/2012 01:49'!
obtenerResultadoRandom

resultados := GenerarResultadoRandom obtener: 15 hasta: 100.! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:50'!
pagarlesAlasAgencias
| tamanio |
self apuestas do: [:apuesta | apuesta agencia recibiPlata: (self porcentajeAgencia * apuesta montoApostado /100)].

! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'MPampin 9/7/2012 01:07'!
premioAciertos: cantAciertos monto: dineroApostado
^ (cantAciertos / 3) raisedTo: 3 * dineroApostado 
! !

Juego subclass: #Prode
	uses: Poceado
	instanceVariableNames: 'criterio1 criterio2 criterio3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

Prode class
	uses: Poceado classTrait
	instanceVariableNames: ''!

!Prode methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 17:03'!
apuestas 
^apuestas.! !

!Prode methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:00'!
generarPremios 

criterio1 := Criterio new.
criterio1 cantidadIgualdades: 13.
criterio2 := Criterio new.
criterio2 cantidadIgualdades: 12.
criterio3 := Criterio new.
criterio3 cantidadIgualdades: 11.
self crearPremioCon: criterio1 yNumero: 50.
self crearPremioCon: criterio2 yNumero: 35.
self crearPremioCon: criterio3 yNumero: 11.
! !

!Prode methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 15:32'!
obtenerResultadoRandom 
^resultados := GenerarResultadoRandom obtener: 13 hasta: 3.
! !

!Prode methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:37'!
pagoExtra
^pagoExtra! !

!Prode methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:37'!
porcentajeAgencia
^porcentajeAgencia .! !

!Prode methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:37'!
porcentajeAgenciaExtra 
^porcentajeAgenciaExtra .! !

!Prode methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 18:37'!
premios
^premios! !

Juego subclass: #Quiniela
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

Object subclass: #Jugador
	uses: ReceptorDinero
	instanceVariableNames: 'agencia apuesta misApuestas capital'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

Jugador class
	uses: ReceptorDinero classTrait
	instanceVariableNames: ''!

!Jugador methodsFor: 'as yet unclassified' stamp: 'Fede 9/3/2012 16:36'!
apuestas
^misApuestas .! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 11:28'!
capital
^capital .! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 11:21'!
capital:unMonto 
	capital := unMonto .! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 12:03'!
initialize 
capital := 0.
misApuestas := OrderedCollection new.
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 15:07'!
jugar:unosNumeros en:unSorteo apostando:unMonto en:unaAgencia.
apuesta:= Apuesta new.
apuesta juego: unSorteo .
apuesta jugador: self.
apuesta agencia: unaAgencia .
apuesta numerosApostados:unosNumeros.
apuesta montoApostado: unMonto .
misApuestas add: apuesta.
unSorteo recibiApuesta: apuesta.
^apuesta .! !

Object subclass: #Premio
	instanceVariableNames: 'criterio juego misGanadores numero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

!Premio methodsFor: 'as yet unclassified' stamp: 'Fede 9/2/2012 23:40'!
criterio
^criterio.
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 11:48'!
criterio:unCriterio
criterio:= unCriterio .
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 16:48'!
initialize 
misGanadores :=OrderedCollection new.
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Fede 9/2/2012 23:46'!
juego
^juego.
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 11:48'!
juego:unJuego
juego:=unJuego .
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Fede 9/3/2012 17:29'!
misGanadores 
^misGanadores .! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Fede 9/5/2012 11:50'!
numero
^numero.
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 11:48'!
numero:unNumero
numero:=unNumero .
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Fede 8/31/2012 00:39'!
pagar:unMonto a:unJugador
unJugador recibiPlata: unMonto.! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 15:34'!
sosGanadoPor:unaApuesta

^ (criterio compara: unaApuesta  numerosApostados con: juego resultados) ifTrue:[misGanadores add: unaApuesta ].! !

Object subclass: #Sorteo
	instanceVariableNames: 'jugadores juego apuestas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1'!

!Sorteo methodsFor: 'as yet unclassified' stamp: 'Fede 9/2/2012 23:30'!
apuestas
^apuestas.! !

!Sorteo methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 10:32'!
initialize 
apuestas := OrderedCollection new.! !

!Sorteo methodsFor: 'as yet unclassified' stamp: 'Fede 9/2/2012 23:33'!
juego
^juego.! !

!Sorteo methodsFor: 'as yet unclassified' stamp: 'Fede 9/6/2012 11:40'!
juego:unJuego
juego := unJuego .
! !

!Sorteo methodsFor: 'as yet unclassified' stamp: 'Fede 9/7/2012 15:10'!
jugar
juego jugarCon: apuestas .! !

!Sorteo methodsFor: 'as yet unclassified' stamp: 'Fede 9/2/2012 23:30'!
recibiApuesta:unaApuesta.
apuestas add: unaApuesta .! !
